#!/usr/bin/perl
#use FCGI;
#-------------------------------------------------------------------------------#
#       $input_string  $ENV{'CONTENT_LENGTH'}
read (STDIN, $input_string, $ENV{'CONTENT_LENGTH'});

#      
@input_pairS = split "&", $input_string;
#       
foreach $input_pair (@input_pairS)
 {
  #   -  
  ($name, $value) = split "=", $input_pair;
  $FORM{$name} = $value;
  #   -  
  ($key, $content) = split "=", $input_pair, 2;
  #     
  $content =~ s/\+/ /g;
  #  
  $content =~ s/%([a-fA-F--0-9][a-fA-F--0-9])/pack "C", hex($1)/eg;
  #    
  $content =~ s/\r//g;
  $FORM{$key} = $content;
 }

#-------------------------------------------------------------------------------#
#  
%language_list = ('0','', '1','', '2','', '3','', '4','', '5','', '128','', '129',' ', '130',' ', '131','');
#     
my $main_file = $FORM{'main_file'};

#-------------------------------------------------------------------------------#
sub get_WORD
 {
  # $_[0] - , $_[1] -   , $_[2] -    
  # v -    ,    
  # V -    ,    
  return unpack "v", (substr $_[0],$_[1],4);
 }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  if(!-r $main_file){ $stat_info .= (":  $main_file       !<br>"); reset_document(); };
  open FILE,$main_file;
  $stat_info .= ($_[1]."    ".$_[0]."<br>");
  binmode FILE;
  seek FILE,$_[0],0; read FILE,$_[2],$_[1];
  close FILE;
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.document.open_string_form.reset();
  parent.FLAG_no_action = 0;
  parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
  // --></script>
HTML

  exit;
 }

sub get_date
 {
  ($day, $mn, $yr) = (localtime)[3..5];
  if($day < 10){ $day = "0$day"; };
  $mn = ($mn < 10) ? "0($mn+1)" : ($mn+1);
  if($yr < 2000){ $yr += 1900; };
  return "$day$mn$yr";
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }
#-------------------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";

if($main_file ne "")
 {
  #  
  if(!-r $main_file){ $stat_info .= (":  ".$main_file."       !<br>"); reset_document(); };
  open FILE,$main_file;
  #$stat_info .= ("   ... ");
  #     ( )
  (undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
  #$stat_info .= ($file_size." <br>");
  #  
  close FILE;
	
  if($FORM{'file_size'} ne $file_size)
   {
	  $stat_info .= ("  : ".$main_file." ...<br>");
	  $stat_info .= ("->     ... ");
    read_block(0,20,$header);
    #   
    $file_type = substr $header,0,4;
    if($file_type ne "TLK ")
     {
      $stat_info .= (":   ".$main_file."  !<br>");
      reset_document();
     };
    #  
    $file_version = substr $header,4,4;
    if($file_version eq "V3.0")
     {
      #   (    )
      $languageID = get_DWORD($header,8); $file_language = $language_list{$languageID};
      #     
      $file_strings = (get_DWORD($header,12) - 1);
      #        
      $strings_offset = get_DWORD($header,16);
     }
    elsif($file_version eq "V1  ")
     {
      $languageID = get_WORD($header,8); $file_language = $language_list{$languageID};
      $file_strings = (get_DWORD($header,10) - 1);
      $strings_offset = get_DWORD($header,14);
     }
   }
  else
   {
    #        
    $file_size = $FORM{'file_size'};
    $file_type = $FORM{'file_type'};
    $file_version = $FORM{'file_version'};
    $languageID = $FORM{'languageID'}; $file_language = $language_list{$languageID};
    $file_strings = $FORM{'current_file_strings'};
    $strings_offset = $FORM{'strings_offset'};
   }  
 };

if($file_version eq "V3.0")
 { $header_length = 20; $string_data_length = 40; }
elsif($file_version eq "V1  ")
 { $header_length = 18; $string_data_length = 26; }

#     
if($file_strings ne "")
 { $string_number = ($FORM{'string_number'} < $file_strings) ? $FORM{'string_number'} : $file_strings; }
else
 { $string_number = ($FORM{'string_number'} < $FORM{'current_file_strings'}) ? $FORM{'string_number'} : $FORM{'current_file_strings'}; }

$stat_info .= ("   $string_number ...<br>");

#  
if($main_file ne "")
 {
  $stat_info .= ("->      ... ");
  read_block($string_data_length*$string_number+$header_length,$string_data_length,$sdt_offset);
  if($file_version eq "V3.0")
   {
    #  
    $string_flag = get_DWORD($sdt_offset,0);
    #     
    $sound_link = (substr $sdt_offset,4,16); $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    #     
    $string_offset = ($strings_offset + get_DWORD($sdt_offset,28));
    #    
    $string_length = get_DWORD($sdt_offset,32);
    #      
    $sound_volume = get_DWORD($sdt_offset,20);
    #  /    
    $sound_pitch = get_DWORD($sdt_offset,24);
    #    32-   
    $sound_length = unpack "f", (substr $sdt_offset,36,4);
   }
  elsif($file_version eq "V1  ")
   {
    $string_flag = get_WORD($sdt_offset,0);
    $sound_link = (substr $sdt_offset,2,8); $sound_link =~ s/\W//g; if($sound_link eq ""){ $sound_link = ""; };
    $string_offset = ($strings_offset + get_DWORD($sdt_offset,18));
    $string_length = get_DWORD($sdt_offset,22);
    $sound_volume = get_DWORD($sdt_offset,10);
    $sound_pitch = get_DWORD($sdt_offset,14);
    $sound_length = " ";
   }
  $stat_info .= ("->    ... ");
  read_block($string_offset,$string_length,$string_text);
  #   (5c),   (0a  0d)   (22)  
  $string_text =~ s/\x5c/\\x5c/g;
  $string_text =~ s/\x0a/\\x0a/g;
  if($string_text =~ /\x0d/){ $stat_info .= ("->     ...<br>"); $string_text =~ s/\x0d/\\x0d/g; };
  $string_text =~ s/\x22/\\x22/g;
 };

#       
if($FORM{'add_file'} ne "")
 {
  if(!-r $FORM{'add_file'})
   {
    $stat_info .= (":   ".$FORM{'add_file'}."       !<br>"); }
  else
   {
    open FILE2,$FORM{'add_file'}; binmode FILE2;
    #   
    seek FILE2,4,0; read FILE2,$file2_version,4;
    #   
    seek FILE2,0,0; read FILE2,$file2_type,4;
    if($file2_type ne "TLK ")
     { $stat_info .= (":  ".$FORM{'add_file'}."    TLK !<br>"); }
    elsif($file2_version eq "V3.0")
     {
      #  
      $header2_length = 20;
      #    
      $string2_data_length = 40;
      #    
      seek FILE2,12,0; read FILE2,$file2_strings,4; $file2_strings = (unpack "V", $file2_strings) - 1;
      #        
      seek FILE2,16,0; read FILE2,$strings2_offset,4; $strings2_offset = unpack "V", $strings2_offset;
      #     
      if($file2_strings ne "")
       { $string2_number = ($FORM{'string_number'} < $file2_strings) ? $FORM{'string_number'} : $file2_strings; }
      else
       { $string2_number = ($FORM{'string_number'} < $FORM{'current_file_strings'}) ? $FORM{'string_number'} : $FORM{'current_file_strings'}; }
      #   2   
      seek FILE2,$header2_length + $string2_data_length * $string2_number,0; read FILE2,$sdt2_offset,$string2_data_length;
      $string2_offset = $strings2_offset + (unpack "V", substr $sdt2_offset,28,4);
      #   2  
      $string2_length = unpack "V", substr $sdt2_offset,32,4;
      #   2
      seek FILE2,$string2_offset,0; read FILE2,$string2_text,$string2_length;
     }
    elsif($file2_version eq "V1  ")
     {
      $header2_length = 18;
      $string2_data_length = 26;
      seek FILE2,10,0; read FILE2,$file2_strings,4; $file2_strings = (unpack "V", $file2_strings) - 1;
      seek FILE2,14,0; read FILE2,$strings2_offset,4; $strings2_offset = unpack "V", $strings2_offset;
      if($file2_strings ne "")
       { $string2_number = ($FORM{'string_number'} < $file2_strings) ? $FORM{'string_number'} : $file2_strings; }
      else
       { $string2_number = ($FORM{'string_number'} < $FORM{'current_file_strings'}) ? $FORM{'string_number'} : $FORM{'current_file_strings'}; }
      seek FILE2,$header2_length + $string2_data_length * $string2_number,0; read FILE2,$sdt2_offset,$string2_data_length;
      $string2_offset = $strings2_offset + (unpack "V", substr $sdt2_offset,18,4);
      $string2_length = unpack "V", substr $sdt2_offset,22,4;
      seek FILE2,$string2_offset,0; read FILE2,$string2_text,$string2_length;
     }
    else{ $stat_info .= (":    ".$FORM{'add_file'}."  !<br>"); }
    close FILE2;
   }
  if($file2_type eq "TLK " && ($file2_version eq "V3.0" || $file2_version eq "V1  "))
   {
    $stat_info .= ("->   ... ".$string2_length."    ".$string2_offset." ( ".$file2_version.")<br>");
    #   (5c),   (0a  0d)   (22)  
    $string2_text =~ s/\x5c/\\x5c/g;
    $string2_text =~ s/\x0a/\\x0a/g;
    $string2_text =~ s/\x0d/\\x0d/g;
    $string2_text =~ s/\x22/\\x22/g;
   }
 };

$stat_info =~ s/\x5c/\\x5c/g;
my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";

#      
print <<HTML;
<script type='text/javascript'><!--

if("$main_file" != "")
 {
  parent.document.main_form.string_content.value = "$string_text";
  parent.document.getElementById("string_info").style.display = "";
  parent.document.getElementById("string_no_info").style.display = "none";
  parent.document.main_form.to_undo_button.style.display = "";
  parent.document.main_form.from_undo_button.style.display = "none";

  parent.document.getElementById("string_flag").innerHTML = "$string_flag";
  parent.document.getElementById("string_length").innerHTML = "$string_length";
  parent.document.getElementById("string_offset").innerHTML = "$string_offset";
  parent.document.getElementById("sound_link").innerHTML = "$sound_link";
  parent.document.getElementById("sound_volume").innerHTML = "$sound_volume";
  parent.document.getElementById("sound_pitch").innerHTML = "$sound_pitch";
  parent.document.getElementById("sound_length").innerHTML = "$sound_length";
 };

if("$FORM{'add_file'}" != "")
 {
  parent.document.main_form.string_content2.value = "$string2_text";
  parent.document.main_form.string_content2.title = " .   $string2_number.         .";
 };

if("$FORM{'file_size'}" != "$file_size")
 {
  parent.document.main_form.file_size.value = "$file_size";
  parent.document.main_form.file_type.value = "$file_type";
  parent.document.main_form.file_version.value = "$file_version";
  parent.document.main_form.languageID.value = "$languageID";
  parent.document.main_form.strings_offset.value = "$strings_offset";
  if("$file_strings" != "")
   { parent.document.main_form.string_number.value = ("$FORM{'string_number'}" < "$file_strings") ? "$FORM{'string_number'}" : "$file_strings"; }
  else
   { parent.document.main_form.string_number.value = ("$FORM{'string_number'}" < "$FORM{'current_file_strings'}") ? "$FORM{'string_number'}" : "$FORM{'current_file_strings'}"; }
  parent.document.main_form.file_strings.value = "$file_strings";
  parent.document.main_form.current_file_strings.value = "$file_strings";
  parent.document.getElementById("file_info").innerHTML = ": $file_size , : $file_type, : $file_version, : $file_language (<span style='cursor: help;' title='  , languageID.'>$languageID</span>)";
  parent.reset_sound_links_list();
 };

parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
parent.document.open_string_form.reset();
parent.FLAG_no_action = 0;
parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
// --></script>
HTML
